unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GLObjects, GLScene, GLScreen, GLMisc, GLTexture, GLCadencer, GLBehaviours,
  ExtCtrls, StdCtrls, Geometry, AsyncTimer, Buttons, PJActiveBtn, PJSpin,
  WybKombEulera, Equations;

type
  TForm1 = class(TForm)
    T14: TPJSpin;
    T24: TPJSpin;
    T34: TPJSpin;
    T44: TPJSpin;
    T13: TPJSpin;
    T23: TPJSpin;
    T33: TPJSpin;
    T43: TPJSpin;
    T12: TPJSpin;
    T22: TPJSpin;
    T32: TPJSpin;
    T42: TPJSpin;
    T11: TPJSpin;
    T21: TPJSpin;
    T31: TPJSpin;
    T41: TPJSpin;
    prosta_x: TPJSpin;
    prosta_y: TPJSpin;
    prosta_z: TPJSpin;
    prosta_kat: TPJSpin;
    euler_a1: TPJSpin;
    euler_b1: TPJSpin;
    euler_c1: TPJSpin;
    euler_a2: TPJSpin;
    euler_b2: TPJSpin;
    euler_c2: TPJSpin;
    kombinacje: TWyborKombinacjiEulera;

    rotX0plus: TPJActiveBtn;
    rotX0minus: TPJActiveBtn;
    rotY0plus: TPJActiveBtn;
    rotZ0plus: TPJActiveBtn;
    rotY0minus: TPJActiveBtn;
    rotZ0minus: TPJActiveBtn;
    rotXplus: TPJActiveBtn;
    rotXminus: TPJActiveBtn;
    rotYplus: TPJActiveBtn;
    rotZplus: TPJActiveBtn;
    rotYminus: TPJActiveBtn;
    rotZminus: TPJActiveBtn;
    btnInfoKosinusy: TPJActiveBtn;
    btnInfoProsta: TPJActiveBtn;
    btnInfoEuler: TPJActiveBtn;
    btnAnimacjaProsta: TPJActiveBtn;
    btnAnimacjaEuler1: TPJActiveBtn;
    btnAnimacjaEuler2: TPJActiveBtn;

    scena: TGLScene;
    kamera: TGLCamera;
    swiatlo1: TGLLightSource;
    AsyncTimer1: TAsyncTimer;
    swiatlo2: TGLLightSource;

    uklad_bazowy: TDummyCube;
    osbazowaX: TCylinder;
    osbazowaY: TCylinder;
    osbazowaZ: TCylinder;
    osbazowaXs: TCone;
    osbazowaYs: TCone;
    osbazowaZs: TCone;
    prosta: TCylinder;

    uklad_nowy: TDummyCube;
    kula: TSphere;
    osnowaX: TCylinder;
    osnowaY: TCylinder;
    osnowaZ: TCylinder;
    osnowaXs: TCone;
    osnowaYs: TCone;
    osnowaZs: TCone;
    uklad_koncowy: TDummyCube;
    oskoncowaX: TCylinder;
    oskoncowaY: TCylinder;
    oskoncowaZ: TCylinder;
    oskoncowaXs: TCone;
    oskoncowaYs: TCone;
    oskoncowaZs: TCone;

    panInfoKosinusy: TPanel;
    panInfoProsta: TPanel;
    panInfoEuler: TPanel;
    DrawEquation1: TDrawEquation;
    DrawEquation2: TDrawEquation;
    DrawEquation3: TDrawEquation;
    DrawEquation4: TDrawEquation;
    DrawEquation5: TDrawEquation;
    DrawEquation6: TDrawEquation;
    DrawEquation7: TDrawEquation;
    DrawEquation8: TDrawEquation;
    DrawEquation9: TDrawEquation;
    DrawEquation10: TDrawEquation;
    DrawEquation11: TDrawEquation;
    DrawEquation12: TDrawEquation;
    DrawEquation13: TDrawEquation;
    DrawEquation14: TDrawEquation;
    DrawEquation15: TDrawEquation;
    DrawEquation16: TDrawEquation;
    DrawEquation17: TDrawEquation;
    DrawEquation18: TDrawEquation;
    DrawEquation19: TDrawEquation;
    DrawEquation20: TDrawEquation;
    DrawEquation21: TDrawEquation;
    DrawEquation22: TDrawEquation;
    DrawEquation23: TDrawEquation;
    eq_eulera1: TDrawEquation;
    eq_eulera2: TDrawEquation;
    eq_eulerb: TDrawEquation;
    eq_eulerc: TDrawEquation;

    panviewer: TPanel;
    viewer: TGLSceneViewer;

    Panel1: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel2: TPanel;
    Panel6: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Shape1: TShape;
    panOpis: TPanel;
    Label19: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    opis: TScrollBox;
    Label20: TLabel;
    Label25: TLabel;
    PJActiveBtn1: TPJActiveBtn;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Panel7: TPanel;
    lbFps: TLabel;
    btnWyzerujBazowy: TPJActiveBtn;
    btnWyzerujNowy: TPJActiveBtn;
    Panel8: TPanel;
    btnOpis: TPJActiveBtn;
    btnWyjscie: TPJActiveBtn;
    panPrzykrywka: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure viewerMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure viewerMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure rotPress(Sender:TPJActiveBtn; Button:TMouseButton; counter: Integer);
    procedure btnWyjsciePress(Sender:TPJActiveBtn; Button:TMouseButton; counter: Integer);
    procedure rotActivate(Sender: TObject);
    procedure rotDeactivate(Sender: TObject);
    procedure viewerAfterRender(Sender: TObject);
    procedure btnWyzerujNowyPress(Sender: TPJActiveBtn; Button: TMouseButton;
      counter: Integer);
    procedure btnWyzerujBazowyPress(Sender: TPJActiveBtn; Button: TMouseButton;
      counter: Integer);
    procedure btnInfoKosinusyPress(Sender: TPJActiveBtn;
      Button: TMouseButton; counter: Integer);
    procedure btnInfoKosinusyRelease(Sender: TObject);
    procedure btnInfoProstaPress(Sender: TPJActiveBtn;
      Button: TMouseButton; counter: Integer);
    procedure btnInfoProstaRelease(Sender: TObject);
    procedure btnInfoEulerPress(Sender: TPJActiveBtn; Button: TMouseButton;
      counter: Integer);
    procedure btnInfoEulerRelease(Sender: TObject);
    procedure btnAnimacjaProstaPress(Sender: TPJActiveBtn;
      Button: TMouseButton; counter: Integer);
    procedure kombinacjeChange(Sender: TObject);
    procedure prostaChange(Sender: TObject);
    procedure eulerChange(Sender: TObject);
    procedure btnAnimacjaEulerPress(Sender: TPJActiveBtn;
      Button: TMouseButton; counter: Integer);
    procedure rotRelease(Sender: TObject);
    procedure btnOpisPress(Sender: TPJActiveBtn; Button: TMouseButton;
      counter: Integer);
    procedure TxxChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    fDragX,fDragY: Integer;
    fUpdating: Boolean;
    procedure updateControls;
    procedure animacjaPrepare;
    procedure animacjaFinish;
    procedure animacja(axis:TAffineVector; deg:Integer);
    function euler_os(i:Integer):TAffineVector;
  public
  end;

var
  Form1: TForm1;

implementation

uses katy_eulera;

{$R *.DFM}


function MatrixNormalize(m:TMatrix):TMatrix;
begin
  NormalizeVector(m[0]);
  NormalizeVector(m[1]);
  NormalizeVector(m[2]);
  NormalizeVector(m[3]);
  Result:= m;
end;

(*********************************************************)

// INICJALIZACJA

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetFullscreenMode( GetIndexFromResolution(800,600,32) );
  WindowState:= wsMaximized;
  opis.VertScrollBar.Position:= 0;
  if (ParamStr(1)='debug') then lbFps.Show;
  fUpdating:= False;
  btnWyzerujBazowy.Press;
  btnWyzerujNowy.Press;
  updateControls;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  panPrzykrywka.SetBounds(0, panViewer.Top, ClientWidth, ClientHeight-panViewer.Top);
  panOpis.SetBounds(
    (panPrzykrywka.Width - panOpis.Width) div 2,
    panPrzykrywka.Top + 10,
    panOpis.Width,
    panPrzykrywka.Height - 20);
  //  800 - 78
  // 1024 - 110
  kamera.FocalLength:= (78 + 32/224*(screen.width-800)) * (96/Screen.PixelsPerInch);
end;

procedure TForm1.viewerAfterRender(Sender: TObject);
const x: Integer = 0;
var fps: Single;
begin
  fps:= viewer.FramesPerSecond;
  if fps=0 then begin
    // jeszcze sie do konca nie zaladowal
    viewer.Invalidate;
    Exit;
  end;
  lbFps.Caption:= Format('%3.0f fps', [fps]);
  if (x<20) and (fps>100) then begin
    // jesli jest akcelerator 3D - mozna troche
    // poszale ze stopniem skomplikowania sceny
    osbazowaX.Slices:= succ(osbazowaX.Slices);
    osbazowaY.Slices:= succ(osbazowaY.Slices);
    osbazowaZ.Slices:= succ(osbazowaZ.Slices);
    osbazowaXs.Slices:= succ(osbazowaX.Slices);
    osbazowaYs.Slices:= succ(osbazowaY.Slices);
    osbazowaZs.Slices:= succ(osbazowaZ.Slices);
    osnowaX.Slices:= succ(osnowaX.Slices);
    osnowaY.Slices:= succ(osnowaY.Slices);
    osnowaZ.Slices:= succ(osnowaZ.Slices);
    osnowaXs.Slices:= succ(osnowaX.Slices);
    osnowaYs.Slices:= succ(osnowaY.Slices);
    osnowaZs.Slices:= succ(osnowaZ.Slices);
    kula.Slices:= succ(kula.Slices);
    kula.Stacks:= succ(kula.Stacks);
    viewer.Invalidate;
    Inc(x);
  end;
end;

(*********************************************************)

// ZEROWANIE UKADW

procedure TForm1.btnWyzerujBazowyPress(Sender: TPJActiveBtn;
  Button: TMouseButton; counter: Integer);
begin
  with uklad_bazowy do begin
    Matrix:= IdentityHmgMatrix;
    Pitch(90);
    Roll(90);   // <<< teraz mamy: Z-w gr, Y-w prawo, X-do nas
    Turn(-20);  // <<< pochylamy go troch w d
    Roll(20);   // <<< obracamy w lewo
  end;
  updateControls;
end;

procedure TForm1.btnWyzerujNowyPress(Sender: TPJActiveBtn;
  Button: TMouseButton; counter: Integer);
begin
  uklad_nowy.Matrix:= IdentityHmgMatrix;
  updateControls;
end;

(*=======================================================*)

// PRZYCISKI X+, X-, Y+, Y-, ...

procedure TForm1.rotPress(Sender:TPJActiveBtn; Button:TMouseButton; counter: Integer);
var d: Single;
    l: TAffineVector;
begin
  if (counter=2) then Sender.Interval:= 50;
  if Button=mbLeft
   then d:= DegToRad(1)
   else d:= DegToRad(5);
  if Pos('plus', TControl(Sender).Name)>0 then d:= -d;
  if Pos('X', TControl(Sender).Name)>0 then l:= XVector else
  if Pos('Y', TControl(Sender).Name)>0 then l:= YVector else
  if Pos('Z', TControl(Sender).Name)>0 then l:= ZVector;
  if Pos('0', TControl(Sender).Name)=0 then l:= VectorTransform(l, uklad_nowy.Matrix);
  uklad_nowy.Matrix:= MatrixNormalize( Pitch(uklad_nowy.Matrix, l, d) );
  updateControls;
end;

procedure TForm1.rotRelease(Sender: TObject);
begin
  (Sender as TPJActiveBtn).Interval:= 200;
end;

procedure TForm1.rotActivate(Sender: TObject);
var obj: TGLSceneObject;
begin
  rotDeactivate(nil);
  if (Sender=rotX0plus) or (Sender=rotX0minus) then obj:= osbazowaX else
  if (Sender=rotY0plus) or (Sender=rotY0minus) then obj:= osbazowaY else
  if (Sender=rotZ0plus) or (Sender=rotZ0minus) then obj:= osbazowaZ else
  if (Sender=rotXplus) or (Sender=rotXminus) then obj:= osnowaX else
  if (Sender=rotYplus) or (Sender=rotYminus) then obj:= osnowaY else
  if (Sender=rotZplus) or (Sender=rotZminus) then obj:= osnowaZ else Exit;
  obj.Material.FrontProperties.Diffuse.Color:= clrYellow;
  if (Sender=rotX0plus) or (Sender=rotX0minus) then obj:= osbazowaXs else
  if (Sender=rotY0plus) or (Sender=rotY0minus) then obj:= osbazowaYs else
  if (Sender=rotZ0plus) or (Sender=rotZ0minus) then obj:= osbazowaZs else
  if (Sender=rotXplus) or (Sender=rotXminus) then obj:= osnowaXs else
  if (Sender=rotYplus) or (Sender=rotYminus) then obj:= osnowaYs else
  if (Sender=rotZplus) or (Sender=rotZminus) then obj:= osnowaZs else Exit;
  obj.Material.FrontProperties.Diffuse.Color:= clrYellow;
end;

procedure TForm1.rotDeactivate(Sender: TObject);
begin
  osbazowaX.Material.FrontProperties.Diffuse.Color:= clrDkGreenCopper;
  osbazowaY.Material.FrontProperties.Diffuse.Color:= clrDkGreenCopper;
  osbazowaZ.Material.FrontProperties.Diffuse.Color:= clrDkGreenCopper;
  osbazowaXs.Material.FrontProperties.Diffuse.Color:= clrDkGreenCopper;
  osbazowaYs.Material.FrontProperties.Diffuse.Color:= clrDkGreenCopper;
  osbazowaZs.Material.FrontProperties.Diffuse.Color:= clrDkGreenCopper;
  osnowaX.Material.FrontProperties.Diffuse.Color:= clrRed;
  osnowaY.Material.FrontProperties.Diffuse.Color:= clrGreen;
  osnowaZ.Material.FrontProperties.Diffuse.Color:= clrBlue;
  osnowaXs.Material.FrontProperties.Diffuse.Color:= clrRed;
  osnowaYs.Material.FrontProperties.Diffuse.Color:= clrGreen;
  osnowaZs.Material.FrontProperties.Diffuse.Color:= clrBlue;
end;

(*=======================================================*)

// OBRACANIE UKADW MYSZK

procedure TForm1.viewerMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  fDragX:= X;
  fDragY:= Y;
end;

procedure TForm1.viewerMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var old,new,l: TAffineVector;
    a: Single;
  function getVector(x,y:Single):TAffineVector;
  var a,z,d: Single;
      m: TMatrix;
  begin
    if Shift=[ssRight]
     then d:= 230
     else d:= 150;
    x:= (x-viewer.Width div 2)/d;
    y:= (-y+viewer.Height div 2)/d;
    a:= x*x + y*y;
    if a<1
     then z:= sqrt(1-a)
     else z:= 0;
    MakeVector(Result, x,y,z);
    if Shift=[ssRight] then Exit;
    m:= uklad_bazowy.Matrix;
    InvertMatrix(m);
    Result:= VectorTransform(Result, m);
  end;
  procedure obroc(uklad:TDummyCube);
  begin
    uklad.Matrix:= MatrixNormalize( Pitch(uklad.Matrix, l, a) );
    updateControls;
  end;
begin
  old:= getVector(fDragX, fDragY);
  new:= getVector(X, Y);
  l:= VectorCrossProduct(old, new);
  a:= -ArcCos(VectorAngleCosine(old, new));
  if Shift=[ssLeft] then obroc(uklad_nowy) else
  if Shift=[ssRight] then obroc(uklad_bazowy);
  fDragX:= X;
  fDragY:= Y;
end;

(*=======================================================*)

// ZMIANY RӯNYCH PARAMETRW

procedure TForm1.kombinacjeChange(Sender: TObject);
begin
  updateControls;
end;

procedure TForm1.TxxChange(Sender: TObject);
var a: Single;
    m: TMatrix;
begin
  a:= (Sender as TPJSpin).Value;
  m:= uklad_nowy.Matrix;
  if Sender=T11 then m[0,0]:= a else
  if Sender=T12 then m[1,0]:= a else
  if Sender=T13 then m[2,0]:= a else
  if Sender=T21 then m[0,1]:= a else
  if Sender=T22 then m[1,1]:= a else
  if Sender=T23 then m[2,1]:= a else
  if Sender=T31 then m[0,2]:= a else
  if Sender=T32 then m[1,2]:= a else
  if Sender=T33 then m[2,2]:= a;
  uklad_nowy.Matrix:= m;
  updateControls;
end;

procedure TForm1.prostaChange(Sender: TObject);
var l: TAffineVector;
    kat: Single;
begin
  if fUpdating then Exit;
  l[0]:= prosta_x.Value;
  l[1]:= prosta_y.Value;
  l[2]:= prosta_z.Value;
  kat:= DegToRad(prosta_kat.Value);
  uklad_nowy.Matrix:= Turn(IdentityHmgMatrix, l, -kat);
  updateControls;
end;

procedure TForm1.eulerChange(Sender: TObject);
var a,b,c: Single;
begin
  if fUpdating then Exit;
  if (Pos('2', TControl(Sender).Name)=0) then begin
    a:= euler_a1.Value;
    b:= euler_b1.Value;
    c:= euler_c1.Value;
  end
  else begin
    a:= euler_a2.Value;
    b:= euler_b2.Value;
    c:= euler_c2.Value;
  end;
  uklad_nowy.Matrix:= IdentityHmgMatrix;
  uklad_nowy.Matrix:= Turn(uklad_nowy.Matrix, euler_os(1), -DegToRad(a));
  uklad_nowy.Matrix:= Turn(uklad_nowy.Matrix, euler_os(2), -DegToRad(b));
  uklad_nowy.Matrix:= Turn(uklad_nowy.Matrix, euler_os(3), -DegToRad(c));
  updateControls;
end;


(*=======================================================*)

// INNE PRZYCISKI

procedure TForm1.btnOpisPress(Sender: TPJActiveBtn; Button: TMouseButton;
  counter: Integer);
begin
  if panOpis.Visible then begin
    panOpis.Hide;
    panPrzykrywka.Hide;
  end
  else begin
    panPrzykrywka.Show;
    panOpis.Show;
  end;
end;

procedure TForm1.btnWyjsciePress(Sender:TPJActiveBtn; Button:TMouseButton; counter: Integer);
begin
  Close;
end;

procedure TForm1.btnInfoKosinusyPress(Sender: TPJActiveBtn;
  Button: TMouseButton; counter: Integer);
begin
  panInfoKosinusy.Show;
  panInfoKosinusy.BringToFront;
end;

procedure TForm1.btnInfoKosinusyRelease(Sender: TObject);
begin
  panInfoKosinusy.Hide;
end;

procedure TForm1.btnInfoProstaPress(Sender: TPJActiveBtn;
  Button: TMouseButton; counter: Integer);
begin
  panInfoProsta.Show;
  panInfoProsta.BringToFront;
end;

procedure TForm1.btnInfoProstaRelease(Sender: TObject);
begin
  panInfoProsta.Hide;
end;

procedure TForm1.btnInfoEulerPress(Sender: TPJActiveBtn; Button: TMouseButton; counter: Integer);

  function el(e:Telement1):string;
  var a,b: string;
  begin
    a:= e.wartosc;
    a:= Format('down(text(%s),text(%s))', [a[1],a[2]]);
    case e.funkcja of
      sinus   : b:= 'text( sin),scale(1.2,symb(a))';
      cosinus : b:= 'text( cos),scale(1.2,symb(a))';
    end;
    if b=''
     then Result:= a
     else Result:= a+', '+b;
  end;

  function el2(e:Telement2):string;
  var a,b: string;
  begin
    a:= el(e[1]);
    if e[1].ilosc<0 then a:= 'text(-),,'+a;
    case e[2].ilosc of
      -1 : b:= 'symb(  -  ), '+el(e[2]);
       1 : b:= 'symb(  +  ), '+el(e[2]);
    end;
    if b=''
     then Result:= a
     else Result:= a+', '+b;
    Result:= 'eq('+Result+')';
  end;

  function caly(kat:string; w:Twzor; minus:Boolean):string;
  begin
    if minus then begin
      w[1][1].ilosc:= -w[1][1].ilosc;
      w[2][1].ilosc:= -w[2][1].ilosc;
    end;
    Result:= 'eq('+
             ' scale(0.7, symb('+kat+')),'+
             ' scale(0.5, text( = arctg2 )),'+
             ' fraq('+el2(w[1])+','+el2(w[2])+' )'+
             ')';
  end;

begin
  if counter>1 then Exit;
  with kombinacje do begin
    eq_eulera1.Description.Text:= caly('a', wzory[Kombinacja, WgStarych][kat1], False);
    eq_eulera2.Description.Text:= caly('a', wzory[Kombinacja, WgStarych][kat1], True);
    eq_eulerb.Description.Text:= caly('b', wzory[Kombinacja, WgStarych][kat2], False);
    eq_eulerc.Description.Text:= caly('g', wzory[Kombinacja, WgStarych][kat3], False);
  end;
  panInfoEuler.Show;
  panInfoEuler.BringToFront;
end;

procedure TForm1.btnInfoEulerRelease(Sender: TObject);
begin
  panInfoEuler.Hide;
end;


(*********************************************************)

// OBLICZENIA I UAKTUALNIANIE KONTROLEK

function sgn(a:Single):Single;
begin
  if a<0
   then Result:= -1
   else Result:= 1;
end;

procedure TForm1.updateControls;
var T: TMatrix;
    nx,ox,ax,
    ny,oy,ay,
    nz,oz,az: Single;
    lx,ly,lz,lk: Single;
    a1,b1,c1,
    a2,b2,c2: Single;
    c: Single;

  function fix(a:Single):Single;
  begin
    if a<-1 then Result:= -1 else
    if a> 1 then Result:=  1 else
    if Abs(a)<1e-20 then Result:= 0
    else Result:= a;
  end;

begin
  if fUpdating then Exit;
  fUpdating:= True;
 try
  T:= uklad_nowy.Matrix;
  nx:= fix(T[0,0]);  ny:= fix(T[0,1]);  nz:= fix(T[0,2]);
  ox:= fix(T[1,0]);  oy:= fix(T[1,1]);  oz:= fix(T[1,2]);
  ax:= fix(T[2,0]);  ay:= fix(T[2,1]);  az:= fix(T[2,2]);
  T11.Value:= nx;    T12.Value:= ox;    T13.Value:= ax;
  T21.Value:= ny;    T22.Value:= oy;    T23.Value:= ay;
  T31.Value:= nz;    T32.Value:= oz;    T33.Value:= az;
  if (nx>=1) and (oy>=1) and (az>=1) then begin
    btnAnimacjaProsta.Enabled:= False;
    btnAnimacjaEuler1.Enabled:= False;
    btnAnimacjaEuler2.Enabled:= False;
    lx:= 0;  ly:= 0;  lz:= 0;  lk:= 0;
    a1:= 0;  b1:= 0;  c1:= 0;
    a2:= 0;  b2:= 0;  c2:= 0;
  end
  else begin
    btnAnimacjaProsta.Enabled:= True;
    btnAnimacjaEuler1.Enabled:= True;
    btnAnimacjaEuler2.Enabled:= True;
    // obliczenie parametrow prostej l
    lk:= arccos( (nx+oy+az-1)/2 );
    c:= cos(lk);
    lx:= sgn(oz-ay) * sqrt(abs((nx-c)/(1-c)));
    ly:= sgn(ax-nz) * sqrt(abs((oy-c)/(1-c)));
    lz:= sgn(ny-ox) * sqrt(abs((az-c)/(1-c)));
    // obliczenie ktw Eulera
    PoliczKatyEulera(
     kombinacje.Kombinacja,
     kombinacje.WgStarych,
     nx, ny, nz,
     ox, oy, oz,
     ax, ay, az,
     a1, b1, c1,
     a2, b2, c2);
  end;
  prosta_x.Value:= lx;
  prosta_y.Value:= ly;
  prosta_z.Value:= lz;
  prosta_kat.Value:= RadToDeg(lk);
  euler_a1.Value:= RadToDeg(a1);
  euler_b1.Value:= RadToDeg(b1);
  euler_c1.Value:= RadToDeg(c1);
  euler_a2.Value:= RadToDeg(a2);
  euler_b2.Value:= RadToDeg(b2);
  euler_c2.Value:= RadToDeg(c2);
 finally
  fUpdating:= False;
 end;
end;

function TForm1.euler_os(i:Integer):TAffineVector;
begin
  case KombinacjeEulera[kombinacje.Kombinacja][i] of
    osX : Result:= XVector;
    osY : Result:= YVector;
    osZ : Result:= ZVector;
  end;
  if not kombinacje.WgStarych then
   Result:= VectorTransform(Result, uklad_nowy.Matrix);
end;


(*********************************************************)

// ANIMACJE

procedure TForm1.animacjaPrepare;
begin
  Enabled:= False;
  uklad_koncowy.Matrix:= uklad_nowy.Matrix;
  uklad_nowy.Matrix:= IdentityHmgMatrix;
  oskoncowaX.Visible:= True;
  oskoncowaY.Visible:= True;
  oskoncowaZ.Visible:= True;
  oskoncowaXs.Visible:= True;
  oskoncowaYs.Visible:= True;
  oskoncowaZs.Visible:= True;
end;

procedure TForm1.animacjaFinish;
begin
  Enabled:= True;
  oskoncowaX.Visible:= False;
  oskoncowaY.Visible:= False;
  oskoncowaZ.Visible:= False;
  oskoncowaXs.Visible:= False;
  oskoncowaYs.Visible:= False;
  oskoncowaZs.Visible:= False;
end;

procedure TForm1.animacja(axis: TAffineVector; deg: Integer);
var i: Integer;
  procedure wait(msec:Cardinal);
  var t: Cardinal;
  begin
    t:= GetTickCount;
    repeat
      Application.ProcessMessages;
      if Application.Terminated then Abort;
    until GetTickCount-t>msec;
  end;
begin
  prosta.Up.AsVector:= VectorMake(axis);
  prosta.Visible:= True;
  try
    wait(1000);
    for i:= 1 to Abs(deg) do begin
      uklad_nowy.Matrix:=
       MatrixNormalize( Turn(uklad_nowy.Matrix, axis, -DegToRad(sgn(deg))) );
      wait(25);
    end;
    wait(1000);
  finally
    prosta.Visible:= False;
  end;
end;

// ANIMACJA - PROSTA

procedure TForm1.btnAnimacjaProstaPress(Sender: TPJActiveBtn;
  Button: TMouseButton; counter: Integer);
var l: TAffineVector;
begin
  l[0]:= prosta_x.Value;
  l[1]:= prosta_y.Value;
  l[2]:= prosta_z.Value;
  animacjaPrepare;
  try
    animacja(l, prosta_kat.IntValue);
  finally
    animacjaFinish;
  end;
end;

// ANIMACJA - KTY EULERA

procedure TForm1.btnAnimacjaEulerPress(Sender: TPJActiveBtn;
  Button: TMouseButton; counter: Integer);
var k1,k2,k3: Integer;
begin
  if Sender=btnAnimacjaEuler1 then begin
    k1:= euler_a1.IntValue;
    k2:= euler_b1.IntValue;
    k3:= euler_c1.IntValue;
  end
  else begin
    k1:= euler_a2.IntValue;
    k2:= euler_b2.IntValue;
    k3:= euler_c2.IntValue;
  end;
  animacjaPrepare;
  try
    animacja(euler_os(1), k1);
    animacja(euler_os(2), k2);
    animacja(euler_os(3), k3);
  finally
    animacjaFinish;
  end;
end;

end.
