program obroty;

uses
  Forms,
  Windows, Messages, SysUtils,
  MainForm in 'MainForm.pas' {Form1},
  katy_eulera in 'katy_eulera.pas';

{$R *.RES}

var
  fontArialBlack: Boolean;
  fontTahoma: Boolean;
  exepath: string;

procedure fontsLoad;
begin
  exepath:= ExtractFilePath(ParamStr(0));
  fontArialBlack:= (Screen.Fonts.IndexOf('Arial Black') < 0);
  fontTahoma:= (Screen.Fonts.IndexOf('Tahoma') < 0);
  if fontArialBlack or fontTahoma then begin
    if fontArialBlack then
      AddFontResource(PChar(exepath+'ARIBLK.TTF'));
    if fontTahoma then begin
      AddFontResource(PChar(exepath+'TAHOMA.TTF'));
      AddFontResource(PChar(exepath+'TAHOMABD.TTF'));
    end;
    SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
  end;
end;

procedure fontsUnload;
begin
  if fontArialBlack or fontTahoma then begin
    if fontArialBlack then
      RemoveFontResource(PChar(exepath+'ARIBLK.TTF'));
    if fontTahoma then begin
      RemoveFontResource(PChar(exepath+'TAHOMA.TTF'));
      RemoveFontResource(PChar(exepath+'TAHOMABD.TTF'));
    end;
    SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
  end;
end;

begin
  Application.Initialize;
  Application.Title := 'Demonstracja obrotw ukadu';
  fontsLoad;
  try
    Application.CreateForm(TForm1, Form1);
    Application.Run;
  finally
    fontsUnload;
  end;
end.
